;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;										;;
;;			   Heart Attack				;;
;;             ============          	;;
;;                                      ;;
;;           By Forklift_Fred           ;;
;;   For SoCodor's Wednesday Workshop   ;;
;;      #138 (13/08/08 - 19/02/08)      ;;
;;                                      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Console = 120,15
; Top Screen = 273,57
; Bottom Screen = 273,345
; Overall Screen = 256 x 480
; Screen resolution = 256 x 192

Global debug=True

AppTitle "Heart Attack - Preview"
Graphics 800,600,32,2
SetBuffer BackBuffer()

Type arrow
	Field x#
	Field y#
	Field dx#
	Field dy#
	Field angle#
	Field frame
	Field launched
	Field strikes
End Type

Type heart
	Field x#
	Field y#
	Field z
	Field dx#
	Field dy#
	Field alive
End Type

Type points
	Field x
	Field y
	Field value
	Field life
End Type

Global mouse_x
Global mouse_y
Global score

Global console=LoadImage("gfx/ds-lite.png")
MaskImage console,255,0,255
Global stylus=LoadImage("gfx/stylus_r.png")
MaskImage stylus,255,0,255
Global arrow_image=LoadAnimImage("gfx/arrow.png",40,40,0,19)
MaskImage arrow_image,255,0,255
Global hearts=LoadAnimImage("gfx/hearts.png",40,40,0,4)
MaskImage hearts,255,0,255
MidHandle hearts

Dim a_offset_x(19)
Dim a_offset_y(19)
For n=0 To 18
	Read a_offset_x(n)
	Read a_offset_y(n)
Next

If stylus Then HidePointer
MoveMouse 400,300

Global screens=CreateImage(256,480)
SetBuffer ImageBuffer(screens)


.start

Global bowy=330
Global bowl=74
Global bowr=180
Global bowc#=(bowr-bowl)/2
Global bow_x#=bowc
Global bow_y#=bowy
Global bow_dx#
Global bow_dy#

Global arrow.arrow
arrow.arrow=New arrow
arrow\x=-128
arrow\y=480
arrow\launched=True
arrow\angle=90

;[Block] Set up default hearts
heart.heart=New heart
heart\x=-40
heart\dx=Rnd(3,4.5)
heart\y=Rnd(144,192)
heart\dy=0
heart\z=4
heart\alive=True

heart.heart=New heart
heart\x=-40
heart\dx=Rnd(2,3)
heart\y=Rnd(96,144)
heart\dy=0
heart\z=3
heart\alive=True

heart.heart=New heart
heart\x=-40
heart\dx=Rnd(1.5,2)
heart\y=Rnd(48,96)
heart\dy=0
heart\z=2
heart\alive=True

heart.heart=New heart
heart\x=-40
heart\dx=Rnd(1,1.5)
heart\y=Rnd(0,48)
heart\dy=0
heart\z=1
heart\alive=True
;[End Block]

Global t_start=MilliSecs()
Global clock=60



Repeat
	Cls
	If KeyDown(203) And bowl>-10 Then
		bowl=bowl-1
		bowr=bowr-1
	End If
	
	If KeyDown(205) And bowr<266 Then
		bowl=bowl+1
		bowr=bowr+1
	End If
	
	If UpdateMouse() Then
		If MouseDown(1) Then
			If bow_y=bowy And mouse_y<=bowy-288 Then
				arrow.arrow=Last arrow
				If arrow\launched Then
					arrow.arrow=New arrow
					SetArrow()
				End If
					
			Else
				arrow.arrow=Last arrow
				If Not arrow\launched Then SetArrow()
			End If
		Else
			LaunchArrow()
		End If
	Else
		LaunchArrow()
	End If
	
	UpdateHearts()
	UpdateArrows()
	
	CheckCollisions()
	UpdatePoints()
	
	
	Color 255,255,255
	Line bowl,bowy,bow_x,bow_y
	Line bowr,bowy,bow_x,bow_y
	
	clock=60-(MilliSecs()-t_start)/1000
	
	Text 3,465,clock
	Text 220,465,RSet(score,4)
	
	If clock=<0 Then GameOver()
	
	UpdateDS()
	
	Flip
	If KeyHit(57) Then
		FlushKeys()
		WaitKey()
	End If
	If clock=<0 Then 
		Delay 2000
		FlushMouse
		While Not MouseHit(1)
			UpdateDS()
			Flip
		Wend
		Exit
	End If
	If KeyHit(1) Then End
Forever

For heart.heart=Each heart
	Delete heart
Next

For arrow.arrow=Each arrow
	Delete arrow
Next

For points.points=Each points
	Delete points
Next

Goto start
End

Function GameOver()
	Color 255,0,0
	Rect 12,300,232,168,1
	Color 255,255,255
	Text 128,384,"Final Score "+score,1,1
End Function

Function SpawnHeart(depth)
	
	Select depth
		Case 1
			x_min=1
			x_max=1.5
			y_min=0
			y_max=48
		Case 2
			x_min=1.5
			x_max=2
			y_min=48
			y_max=96
		Case 3
			x_min=2
			x_max=3
			y_min=96
			y_max=144
		Case 4
			x_min=3
			x_max=4.5
			y_min=144
			y_max=192
	End Select
	
	heart.heart=New heart
	
	heart\dx=Rnd(x_min,x_max)
	heart\y=Rnd(y_min,y_max)
	heart\dy=0
	heart\z=depth
	heart\alive=True
	
	direction=Rnd(1,2)
	If direction=1 Then heart\x=-40
	If direction=2 Then heart\x=296
End Function

Function SetArrow()
	arrow\x=mouse_x
	arrow\y=mouse_y+288
	arrow\dx=(arrow\x-bowl-bowc)/10
	arrow\dy=(arrow\y-bowy)/10
	arrow\angle=Abs(ATan2(arrow\y-bowy-arrow\dy,arrow\x-bowl-bowc-arrow\dx))
	bow_dx=arrow\dx
	bow_dy=arrow\dy
	bow_x=arrow\x
	bow_y=arrow\y
End Function

Function CheckCollisions()
	For arrow.arrow=Each arrow
		If arrow\dy>0 Then
			For heart.heart=Each heart
				If heart\alive Then
					If heart\y<arrow\y+10 And heart\y>arrow\y-10 Then
						If ImagesCollide(arrow_image,arrow\x-a_offset_x(arrow\frame),arrow\y-a_offset_y(arrow\frame),arrow\frame,hearts,heart\x,heart\y,heart\z-1) Then
							d#=Pythag(arrow\x-heart\x,arrow\y-heart\y)
							heart\dx=0
							heart\dy=1
							heart\alive=False
							arrow\strikes=arrow\strikes+1
							value=(25-d)*arrow\strikes
							score=score+value
							points.points=New points
							points\x=heart\x
							points\y=heart\y
							points\value=value
							points\life=255
							SpawnHeart(Rnd(1,4))
						End If
					End If
				End If
			Next
		End If
	Next
End Function

Function UpdatePoints()
	For points.points=Each points
		Color points\life,points\life,points\life
		Text points\x,points\y,points\value
		points\life=points\life-5
		If points\life<0 Then Delete points
	Next
End Function

Function Pythag(x,y)
	sq_x=x*x
	sq_y=y*y
	sq_h=sq_x+sq_y
	h=Sqr(sq_h)
	Return h
End Function

Function UpdateHearts()
	For heart.heart=Each heart
		heart\x=heart\x+heart\dx
		heart\y=heart\y+heart\dy
		If heart\dy Then
			heart\dy=heart\dy+0.7
		Else
			heart\z=Floor(heart\y/48)+1
		End If
		If heart\x<-40 Or heart\x>296 Then heart\dx=-heart\dx
		DrawImage hearts,heart\x,heart\y,heart\z-1
		;Text heart\x+20,heart\y,heart\y
		If heart\y>480 Then Delete heart
	Next
End Function

Function UpdateArrows()
	For arrow.arrow=Each arrow
		;Line arrow\x,arrow\y,arrow\x+(40*Cos(arrow\angle)),arrow\y+(40*Sin(arrow\angle))
		arrow\frame=((90-arrow\angle)/10)+9
		DrawImage arrow_image,arrow\x-a_offset_x(arrow\frame),arrow\y-a_offset_y(arrow\frame),arrow\frame
		If arrow\launched Then
			arrow\x=arrow\x-arrow\dx
			arrow\y=arrow\y-arrow\dy
			arrow\dy=arrow\dy-0.1
			If arrow.arrow=First arrow Then arrow\dy=0
			If arrow\y<bowy And arrow\dy=0 Then Delete arrow
			If arrow\y<0 Or arrow\y>500 Then Delete arrow
		End If
	Next
End Function

Function LaunchArrow()
	arrow.arrow=Last arrow
	If Not arrow\launched Then
		arrow\launched=True
	End If
	bow_x=bow_x-bow_dx
	bow_y=bow_y-bow_dy
	If bow_y<=bowy Then
		bow_y=bowy
		bow_dy=0
		bow_dx=0
		bow_x=bowl+bowc
	End If
End Function

Function UpdateMouse()
	mouse_x=MouseX()-273
	mouse_y=MouseY()-345
	If mouse_x>0 And mouse_x<256 And mouse_y>0 And mouse_y<198 Then
		Return True
	Else
		Return False
	End If
End Function

Function UpdateDS()
	SetBuffer BackBuffer()
	Cls
	DrawImage console,120,15
	CopyRect 0,0,256,192,273,57,ImageBuffer(screens),BackBuffer()
	CopyRect 0,288,256,192,273,345,ImageBuffer(screens),BackBuffer()
	DrawImage stylus,MouseX(),MouseY()
	If debug Then
		Color 255,255,255
		Text 0,0,MouseX()+" , "+MouseY()
		Text 0,15,mouse_x+" , "+mouse_y
	End If
	SetBuffer ImageBuffer(screens)
End Function

Data 3,4
Data 4,8
Data 5,13
Data 7,18
Data 9,23
Data 10,28
Data 13,30
Data 15,34
Data 17,36
Data 19,36
Data 22,35
Data 24,34
Data 27,31
Data 29,28
Data 31,24
Data 33,19
Data 35,13
Data 35,9
Data 36,4











;~IDEal Editor Parameters:
;~F#17#22#2B#60#DB#E2#108#114#130#139#141#151#161#170#17A
;~C#Blitz3D